Subject: Re: [PATCH v3] net: stmmac: Improve Tx timer arm logic further

From: Jakub Kicinski <[email-masked]>
Date: Tue, 2 Jun 2026 19:20:36 -0700

On Thu, 28 May 2026 23:46:59 -0700
[email-masked] wrote:
> There is no race concern: hrtimer_start() is internally serialized and
> safe to call on an active timer. In the event of a race between
> hrtimer_active() and hrtimer_start(), the worst case is calling
> hrtimer_start() on an already-active timer, which is identical to the
> pre-patch behaviour.

I mean.. I wouldn't say that this is not racy. But I think you're not
making it much worse than it already was :S

Could you experiment with deleting all this local driver logic and just
relying on NAPI's built-in defer IRQ mechanism?